<?php
// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

require(__DIR__ . '/../../config.php');

global $CFG, $PAGE, $OUTPUT;

require_once(__DIR__ . '/spacelib.php');

use local_sharedspaceh\metadata\export\space_csv_export,
    local_sharedspaceh\space_form,
    local_sharedspaceh\space_table;

require_login();

$context = context_system::instance();
require_capability('local/sharedspaceh:accesstospaceh',
        $context,
        null,
        true,
        'error_when_accessing',
        'local_sharedspaceh');

const REQUEST_FLAG = 'rk'; // URL parameter to indicate if request data is in the URL.

$table = new space_table('local_sharedspaceh_space_table');

$table->is_downloadable(true);
$download = optional_param('download', '', PARAM_ALPHA);
$table->show_download_buttons_at(array()); // Do not show standard download buttons, as we create our own.

if ($download > '') {
    $exportclass = new space_csv_export($table);
    $table->export_class_instance($exportclass);
    $table->started_output = false; // I don't know why, but when we set a custom export class, this flag is set to true.
    $table->is_downloading('csv');
    $exportclass->start_document(clean_filename('Modules for metadata tagging'), '');
}

$PAGE->set_context($context);
$PAGE->set_url(new moodle_url($CFG->wwwroot.'/local/sharedspaceh/index.php'));
$PAGE->set_pagelayout('standard');
$PAGE->set_title(get_string('sharedspaceh', 'local_sharedspaceh'));

$mform = new space_form();

if (isset($_GET[REQUEST_FLAG])) {
    $mform->fill_data($_GET);
}

if ($mform->get_data() !== null) {
    $request = $mform->generate_space_request();
}

$requestexists = isset($request);

if (!$table->is_downloading()) {
    echo $OUTPUT->header();
    if ( version_compare(moodle_major_version(), '4.0', '>=') ) {
        // For Moodle >= 4.0, add links to what were navigation extensions (not available anymore, big sad).
        $linksmenu = html_writer::link(new moodle_url('/local/sharedspaceh/configpage.php'),
                $OUTPUT->pix_icon('tagging_menu', '', 'local_sharedspaceh') . get_string('tagging_menu_name', 'local_sharedspaceh'),
                [ 'class' => 'd-block' ]);
        if (has_capability('local/sharedspaceh:accessasconfig', context_system::instance())) {
            $linksmenu .= html_writer::link(new moodle_url('/local/metadata/index.php', array('contextlevel' => CONTEXT_MODULE)),
                    $OUTPUT->pix_icon('config_menu', '', 'local_sharedspaceh') . get_string('config_menu_name', 'local_sharedspaceh'),
                    [ 'class' => 'd-block' ]);
        }
        echo html_writer::div($linksmenu, 'float-right');
    }
    echo $OUTPUT->heading('<i class="fa fa-space-shuttle mr-2"></i>' . get_string('sharedspaceh', 'local_sharedspaceh'));


    $PAGE->blocks->load_blocks();
    $PAGE->blocks->create_all_block_instances();

    if (!$PAGE->blocks->is_block_present('sharing_cart')) {
        $PAGE->blocks->add_block('sharing_cart', 'side-pre', 1, true);
    }

//     $jsrequiredmessage = html_writer::div('Javascript is required for the Sharing Space to function correctly', 'text-error');
//     echo html_writer::tag('noscript', $jsrequiredmessage);

    if (!$requestexists) {
        echo local_sharedspaceh_welcome_message();
    }

    $mform->display();
}

// if (!$table->is_downloading() && $requestexists) {
//     echo "<b>Form data:</b><br>";
//     sharedspaceh_debug($mform->get_data());
//     echo "<b>Request:</b><br>";
//     $request->print();
//     echo "<b>Form data (generated by request):</b><br>";
//     sharedspaceh_debug($request->get_form_data());
// }

if ($requestexists) {

    $table->init();
    $table->define_baseurl(new moodle_url($PAGE->url, array_merge($request->to_url_params(), array(REQUEST_FLAG => 1))));

    $table->setup();

    $before = microtime(true);
    $results = $request->run($table->get_sort_columns(), $table->get_sql_sort());
    $seconds = format_float(microtime(true) - $before, 4);

    if (!$table->is_downloading()) {
        echo $OUTPUT->box_start();

        if (!empty($results)) {
            echo html_writer::div(get_string('result', 'local_sharedspaceh', array('nresults' => count($results), 'seconds' => $seconds)), 'small');
        } else {
            echo html_writer::div(get_string('nocoursefound', 'local_sharedspaceh'), 'text-center py-1');
        }
    }

    if (!empty($results)) {
        $table->fill_caseine_table($results);
        $table->finish_output();
    }

    if (!$table->is_downloading()) {
        echo $OUTPUT->box_end();
    }

}

if (!$table->is_downloading()) {
    echo $OUTPUT->footer();
}
